#!/bin/env python

#
# By Filip Kalinski, 2004 - filon@pld.org.pl
#

import urllib
import re
import sys
import os

walmart = { 'search' : { 'url'   : 'http://www.walmart.com/catalog/search-ng.gsp?',
			 'query' : 'search_query',
			 'args'  : { 'search_constraint': '4104', 'ics' : '5', 'ico': '0' },
			 're' :
			[ r'<input type="hidden" name="product_id" value="(\d+)">' ] },
            'result' : { 'url'   : 'http://www.walmart.com/catalog/product.gsp?',
	                 'query' : 'product_id',
			 'args'  : { },
			 're' :
			[ r'<a href="javascript:photo_opener\(\'(\S+.jpg)&product_id=',
			  r'<meta name="Description" content="(.+) at Wal-Mart.*">' ] }
	  }

def search(site, page, keyword):
  s = site[page]
  args = s['args']
  args[s['query']] = keyword
  url = s['url'] + urllib.urlencode(args)
  file = urllib.urlopen(url)
  content = file.read()
  result = []

  for i in s['re']:
    r = re.compile(i, re.M)
    result += [ r.findall(content) ]

  return result

def get_cover(url, name, base_dir, image_name, i):
  file = base_dir
  if file != "":
    file += os.path.sep
  if image_name != "":
    file += image_name
    if i > 0:
      file += str(i)
  else:
    file += urllib.quote(name, '/ ')
  file += '.jpg'

  urllib.URLopener().retrieve(url, file)
  print file

def main(argv):
  try:
    if len(argv) == 0:
      print """Usage: walmart.py \"keyword ... keyword\" [dest_dir] [image_name_no_extension]

You can specify no parameters, only dest_dir parameter, or both dest_dir and
image_name. If you don't specify image_name, files will be named after artist
and album name from Walmart search. If you don't specify dest_dir, files will
go to the current directory.

Example usage:
walmart.py "abbey lincoln straight ahead"
walmart.py "abbey lincoln straight ahead" "D:\Abbey Lincoln\Straight Ahead" "folder"

In second case, file will be saved as "D:\Abbey Lincoln\Straight Ahead\\folder.jpg"
When multiple matches are found, they will be saved as folder.jpg, folder1.jpg, folder2.jpg...

By Filip Kalinski, 2004 (filon@pld.org.pl)
"""
      sys.exit(2)
    else:
      # setup parameters
      keyword = argv[0]
      force_name = ""
      base_dir = ""
      
      if len(argv) > 1:
        base_dir = argv[1]
        if len(argv) > 2:
          force_name = argv[2]
      
      # search for albums
      [albums] = search(walmart, 'search', keyword)
      try:
        i = 0
        for album in albums:
      	  # search for covers
          [cover, name] = search(walmart, 'result', album)
          get_cover(cover[0], name[0], base_dir, force_name, i)
          i += 1
      except:
        pass
  except:
    sys.exit(2)

if __name__ == "__main__":
  main(sys.argv[1:])
